/*Programma main per lanciare dijkstra.c*/

/* Copyright 2004-2005 by Gianfranco Gignina <shinkuro@amiga.it>
 * All Rights Reserved.
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/

#include <stdio.h>
#include "RicercaOperativaDef.h"
#include <stdlib.h>

int main(int argc,char **argv)
{
    int i, j, N, nV=0, risp1, risp2, retfile;
    int V[maxM];
    int A[maxM][maxM];
    float P[maxM][maxM];
    char l, DG, Vp, Va;
    char NFile[maxS], *fileName;


    if (argc!=2)
    {
        printf("Benvenuto!\n");
        printf("Sono il programma che ti permettera' di\n");
        printf("trovare il percorso minimo tra due nodi di un grafo...\n");
        printf("...mediante l'algoritmo di Dijkstra!\n");
        printf("\nInserisci il grafo su file *.grf\n");

        printf(": ");
        scanf("%s", NFile);
        fileName = NFile;
    }
    else fileName = argv[1];

    retfile=leggiFileF(fileName, A, P, &N, &DG);

    if (retfile==NonE)
    {
        printf("Errore nella lettura del file!");
        return 1;
    }

    printf("\nInserisci il nodo di partenza: ");
    scanf("%s", &Vp);
    risp1=num(Vp);



    printf("\nInserisci il nodo di arrivo: ");
    scanf("%s", &Va);
    risp2=num(Va);


    nV=dijkstra(N, DG, P, risp1, risp2, V);

    if (nV == NonE)
    {
        printf("Si e' verificato un errore!\n");
        printf("Per favore controlla che il grafo da analizzare\n");
        printf("sia orientato e che i nodi di cui calcolare il\n");
        printf("percorso minimo abbiano almeno un percorso orientato...");

        return 1;
    }

    printf("\nIl percorso minimo tra i nodi %c e %c e':\n", Vp, Va);

    for (i=0; i<nV; i++)
    {
        l=lett(V[i]);
        l=toupper(l);
        printf("%c", l);
        if (i == nV-1) break;
        printf("-");
    }

    return 0;
}
