/*LeggiFile.c*/

/* Copyright 2004-2005 by Gianfranco Gignina <shinkuro@amiga.it>
 * All Rights Reserved.
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/

/*Programma che legge una matrice di adiacenza e una matrice dei pesi da un file
  di tipo *.grf; dopo averle lette le copia su due matrici temporanee A[][] e
  P[][], successivamente stampa su video le matrici A[][] e P[][]*/

#include <stdio.h>
#include "RicercaOperativaDef.h"
#include <string.h>
#include <stdlib.h>

enum   //semplicemente dichiara delle costanti intere, partendo da 0
{
    stato_init,
    stato_dimensione,
    stato_matrice_adiacenza,
    stato_fine_matrice_adiacenza,
    stato_matrice_pesi,
    stato_fatto,
};

int leggiFileF(char *fileName, int A[][maxM], float P[][maxM], int *N, char *DG)
{
    FILE  *leggi;
    char  DGrafo;
    char  stringaT[maxS], strgTemp[maxR];
    int   i, j, misVE;



    if ((leggi = fopen(fileName, "r")) == NULL)
    {
        printf("Mi spiace ma non riesco a leggere il file...");
        return NonE;
    }
    else
    {
        int stato = stato_init;

        printf("\nLeggo il file...");

        while (fgets(strgTemp, maxR, leggi))
        {
            register char *c;  //puntatore in un registro ad un vettore temporaneo


/* c=strchr(strgTemp,'\n') Trova un '\n' in strgTemp e restituisce un puntatore
   alla posizione in cui si trova '\n' altrimenti ritorna NULL*/
            if ((c = strchr(strgTemp,'\n')) || (c = strchr(strgTemp,'\r')))
                *c = '\0'; // cerca un fine linea \n o \r\n (windows) e inserisce 0
                           // mette uno 0 perch fgets torna anche il fine linea che
                           //  \n o \r\n se stai su windows

            if (*strgTemp == ';') continue;

            if (strncmp(strgTemp,"DGrafo=",7)==0)
            {
               //if (stato!=stato_init) break;

               DGrafo = strgTemp[7];

               continue;
            }

            if (strncmp(strgTemp,"nNodi=",6)==0) // confronta 6 caratteri di strgTemp con
                                                 // la stringa "nNodi=", il valore di
                                                 // ritorno  zero se trova la stringa
                                                 // "nNodi=" in strgTemp
            {
                if (stato!=stato_init) break;

                misVE = atoi(strgTemp+6);
                stato = stato_dimensione;
                continue;
            }

            if (strncmp(strgTemp,"A{",2) == 0)
            {
                if (stato!=stato_dimensione) break;
                i = 0; // inizializzo questo indice per un uso successivo
                stato = stato_matrice_adiacenza;
                continue;
            }

            if (strncmp(strgTemp,"}A",2) == 0)
            {
                if (stato!=stato_matrice_adiacenza) break;
                if (i<misVE) break;
                stato = stato_fine_matrice_adiacenza;
                continue;
            }

            if (strncmp(strgTemp,"P{",2) == 0)
            {
                if (stato!=stato_fine_matrice_adiacenza) break;
                i = 0;
                stato = stato_matrice_pesi;
                continue;
            }

            if (strncmp(strgTemp,"}P",2) == 0)
            {
                if (stato!=stato_matrice_pesi) break;
                if (i<misVE) break;
                stato = stato_fatto;
                break;
            }

            if (i<misVE)
            {
                c = strgTemp;

                for (j = 0; j<misVE; j++)
                {
                    for (; *c && *c==' '; c++); //fin quando *c non  0 e *c  uguale a spazio
                                                //cio c punta ad un carattere non nullo e spazio
                                                //c++, cio vai avanti,ti sposti in strgTemp,
                                                //fino al numero successivo in pratica

                    if (*c)  //serve a vedere se hai messo proprio maxVE colonne
                    {
                        if (stato==stato_matrice_adiacenza)
                        {
                            A[i][j] = atoi(c);
                        }
                        else
                        {
                            P[i][j] = atof(c);
                        }
                    }
                    else break;

                    for (; *c && *c!=' '; c++); //cerca il primo spazio e quindi si posiziona davanti al prossimo numero da considerare nel ciclo

                }

                if (j<misVE) break;
                i++;
            }
            else break;
        }

        fclose(leggi);

        if (stato!=stato_fatto)
        {
            switch (stato)
            {
                case stato_init:
                    printf("Errore: linea \"nNodi=\" mancante\n");
                    break;

                case stato_dimensione:
                    printf("Errore: linea \"A{\" mancante\n");
                    break;

                case stato_matrice_adiacenza:
                    printf("Errore: formato matrice adiacenza errato\n");
                    break;

                case stato_fine_matrice_adiacenza:
                    printf("Errore: linea \"P{\" mancante\n");
                    break;

                case stato_matrice_pesi:
                    printf("Errore: formato matrice pesi errato\n");

                default:
                    printf("Errore: formato matrice adiacenza errato\n");
                    break;
            }
        }

    }


    *N=misVE;
    *DG=DGrafo;

    return 0;
}
