/* Generatore di grafi */

/* Copyright 2004-2005 by Gianfranco Gignina <shinkuro@amiga.it>
 * All Rights Reserved.
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/

/* Programma che produce un file di tipo *.grf contenente le informazioni
   riguardanti il grafo che l'utente vuole costruire:
       Dopo l'inserimento dei dati richiesti da parte dell'utente questo
       programma si avvale principalmenti di due matrici su cui memorizzare
       i dati immessi i quali verranno stampati in seguito su di un file di 
       tipo *.grf   
*/


#include <stdio.h>
#include "RicercaOperativaDef.h"

int main(void)
{
    
//------DICHIARAZIONI-----------------------------------------------------------    
    char risp2 = '?', risp3, l, s, sim = '?';
    int N = 0, i, j, x, n = 0;
    int  A[maxM][maxM];
    float  P[maxM][maxM];
    FILE *grafo;
    char stringaT[maxS], stringaN[maxS+maxE];
//------------------------------------------------------------------------------       
    
    
//Inserimento dei primi dati dall'utente----------------------------------------
    
    printf("Io sono il generatore di grafi semplici.\n");
    printf("Tu dovrai fornirmi alcuni dati...\n");
    printf("..ed io generero' un file di tipo grafo(*.grf)");
    
    while (N < 4 || N > 10)
    {
        printf("\nDa quanti nodi e' formato il tuo grafo?");
        printf("[minimo=4, massimo=10]: ");
        scanf("%d", &N);
    }

    while (sim != 'n' && sim != 's')
    {
        printf("\nVuoi che generi un grafo orientato?[s/n]: ");
        scanf("%s", &sim);
    }    
//------------------------------------------------------------------------------


//Inserimento dati per un grafo di tipo orientato-------------------------------    
    if (sim == 's')
    {
        for (i=0; i<N; i++)
        {
            for (j=0; j<N; j++)
               {
                   if (i != j)
                   {
                      
                      l = lett(i);
                      s = lett(j);
                      risp3 = '?';
                 
                    while (risp3 != 's' && risp3 != 'n')
                     {
                      printf("\nI nodi %c e %c sono in relazione?[s/n]:", l, s);
                      scanf("%s", &risp3);
                              
                      if (risp3 == 's')
                          x = 1;
                      else
                          x = 0;
                     }
                      
                      A[i][j]= x;
                   }
                   else
                    A[i][j]= 0;
               }
               
        }
 
    } 

//------------------------------------------------------------------------------    
    
//Inserimento dati per un grafo di tipo non orientato---------------------------    
    else
    {
       for (i=0; i<N; i++)
        {
            for (j=0; j<N; j++)
               {
                   if (i < j)
                   {
                      
                      l = lett(i);
                      s = lett(j);
                      risp3 = '?';
                 
                     while (risp3 != 's' && risp3 != 'n')
                     {
                      printf("\nI nodi %c e %c sono in relazione?[s/n]:", l, s);
                      scanf("%s", &risp3);
                             
                      if (risp3 == 's')
                          x = 1;
                      else
                          x = 0;
                     }  
                         
                      A[i][j]= x;
                   }
                        
                   if (i == j)
                      A[i][j]= 0;
                              
                   A[j][i] = A[i][j];
               }
        } 
    }          
//------------------------------------------------------------------------------

//Caso del grafo pesato---------------------------------------------------------    
    
    while (risp2 !='n' && risp2 != 's')
    {
       printf("\nIl grafo da generare e' di tipo pesato?[s/n]: ");
       scanf("%s", &risp2);
    }
         
//Genero il grafo pesato SE risp2='s'....    
    if (risp2 == 's')
    {
           
       for (i=0; i<N; i++)
        {
            for (j=0; j<N; j++)
            {
                if (A[i][j] == 1 && i < j)
                {                                   
                   l=lett(i);
                   s=lett(j);
                 
                   printf("\nInserisci il peso dell'arco %c%c:", l, s);
                   scanf("%e", &P[i][j]);
                    
                   P[j][i]= P[i][j];
                }
                //99 = non esiste relazione tra i 2 nodi
                //     e dunque non c' un peso;
                if (A[i][j] == 0)
                   P[i][j] = 99;

//Se il grafo  orientato allora la matrice di adiacenza sar asimmetrica
//dunque bisogna chiedere all'utente i pesi degli archi orientati
                 
                if (sim == 's' && A[i][j]== 1 && i > j )
                {                  
                   l=lett(i);
                   s=lett(j);
                
                   printf("\n?Inserisci il peso dell'arco %c%c:", l, s);
                   scanf("%f", &P[i][j]);
                }     
                    
            }
        }   
    }            
     
//------------------------------------------------------------------------------

//Stampa su file----------------------------------------------------------------
                    
printf("Sto stampando i tuoi dati su un file...\n");

printf("Inserisci il nome del file senza estensione[max=30 caratteri]\n: ");
scanf("%s", &stringaT);

sprintf(stringaN,"%s.grf", stringaT);

if ((grafo = fopen(stringaN, "w")) == NULL)
{
    printf("Mi spiace ma non riesco a creare il file...");
}    
else
{
    fprintf(grafo,";File contenente un grafo (*.grf)\n");
    if (N < 10) fprintf(grafo,"nNodi=0%d\n", N);
    else fprintf(grafo,"nNodi=%d\n", N);

    fprintf(grafo,"DGrafo=%c\n", sim);
    fprintf(grafo,";BEGIN Matrice di adiacenza\n");
    fprintf(grafo,"A");//Carattere di controllo per la matrice di adiacenza
    fprintf(grafo,"%c\n", l=lett(58)); //carattere di controllo di apertura
    
    for (i=0; i<N; i++)
           {
               for (j=0; j<N; j++)
                 fprintf(grafo,"%d ", A[i][j]);
                 fprintf(grafo,"\n");
           }  
    
    fprintf(grafo,"%cA\n", l=lett(60)); //carattere di controllo di chiusura   
              
    fprintf(grafo,";END Matrice di adiacenza\n");       
           
    if (risp2 == 's')
    {

        fprintf(grafo,";BEGIN Matrice dei pesi\n");
        fprintf(grafo,"P");//Carattere di controllo per la matrice dei pesi
        fprintf(grafo,"%c\n", l=lett(58)); //carattere di controllo di apertura    
        
        for (i=0; i<N; i++)
           {
               for (j=0; j<N; j++)
               {
                 fprintf(grafo, "%2.2f ", P[i][j]);
               }
               fprintf(grafo, "\n");    
           }
        
        fprintf(grafo,"%cP\n", l=lett(60)); //carattere di controllo di chiusura   
        
        fprintf(grafo,"END Matrice dei pesi\n");     
    }      
    
    
    fflush(grafo); // libero il buffer
    fclose(grafo);
}                             
 return 0;                                                                                                  
                                                                                                             
}                                
