/*convertMtrxToVE.c*/

/* Copyright 2004-2005 by Gianfranco Gignina <shinkuro@amiga.it>
 * All Rights Reserved.
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/

/*Converte una matrice di adiacenza/pesi in un vettore di strutture arco*/

#include <stdio.h>
#include <stdlib.h>
#include "RicercaOperativaDef.h"

int convertMtrxToVE(int N, char DG, float P[][maxM], arco *E)
{
   int i, j, nArchi = 0; 
    
    

/* Se il grafo  un DGrafo allora il vettore E[] dovr contenere anche gli archi
   descritti nella triangolare inferiore della matrice dei pesi */
//------------------------------------------------------------------------------    
    if (DG == 's')
    {
        for (i=0; i<N; i++)
        {
            for (j=0; j<N; j++)
            {
                if (P[i][j] != NonE)
                {
                    E[nArchi].v1= i;
                    E[nArchi].v2= j;
                    E[nArchi].peso= P[i][j];
                
                    nArchi++;
                }
            }
        }
    }
//------------------------------------------------------------------------------

/* Se il grafo non  un DGrafo verranno prisi in considerazione solo gli archi
   descritti dalla triangolare superiore della matrice dei pesi*/
//------------------------------------------------------------------------------    
    else    
    {
        for (i=0; i<N; i++)
        {
            for (j=0; j<N; j++)
            {
                if (P[i][j] != NonE && i < j)
                {
                    E[nArchi].v1= i;
                    E[nArchi].v2= j;
                    E[nArchi].peso= P[i][j];
                
                    nArchi++;
                }
            }
        }
    }    
    
    return nArchi;            
}
