/*Programma main di Kruscal*/

/* Copyright 2004-2005 by Gianfranco Gignina <shinkuro@amiga.it>
 * All Rights Reserved.
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/


#include <stdio.h>
#include "RicercaOperativaDef.h"

int main(int argc,char **argv)//argc contiene il numero degli 
{                             //argomenti del programma
/* Dichiarazioni*/    
//------------------------------------------------------------------------------    
    int i, j, N, nArchi; // i & j = indici; N = numero dei nodi;
    int A[maxM][maxM]; //matrice di adiacenza ;
    float P[maxM][maxM]; // matrice dei pesi;
    char l, s, DG, risp; // l & s = char temporanei; DG = DGrafo o no?;
    char NFile[maxS]; //NFile[]=stringa dove risieder il nome del file letto ;
    char *fileName; // puntatore a char utilizzato da LeggiFileF();
    arco V[maxM*maxM]; // vettore contenente tutti gli archi del grafo letto...;
//------------------------------------------------------------------------------

/* Se il progr viene lanciato senza il nome del file allora esegue questo...*/
//------------------------------------------------------------------------------    
    if (argc!=2)
    {
        printf("Benvenuto!\n");
        printf("Sono il programma che ti permettera' di\n");
        printf("trovare il minimo albero ricoprente di un grafo...\n");
        printf("...utilizzando l'algoritmo di Kruscal!\n");
        printf("\nInserisci il grafo su file *.grf\n");
    
        printf(": ");
        scanf("%s", &NFile); 
        fileName = NFile; // fileName punta ad NFile;
    }
    else fileName = argv[1]; //Altrimenti legge il nome del file che si trova in
                             //argv[1]...(fileName punta ad argv[1]);
//------------------------------------------------------------------------------
        
    leggiFileF(fileName, A, P, &N, &DG); // Lettura del file....

//------------------------------------------------------------------------------

//------------------------------------------------------------------------------    
    if (N ==0) //Se il numero di nodi  uguale a zero significa che qualcosa 
    {          //nella lettura del file  andato storto....
        printf("Errore nella lettura del file!"); 
        return 1;
    }
//------------------------------------------------------------------------------    

//------------------------------------------------------------------------------    

    nArchi = kruscal(N, DG, P, V); // chiamo la funzione di kruscal...

//------------------------------------------------------------------------------


/* Stampa su viedo dei risultati pervenuti*/
//------------------------------------------------------------------------------    
    printf("\nIl minimo albero ricoprente di questo grafo e':\n");

    
    for (i=0; i<nArchi; i++)
    {
        
        printf("Arco %d: ", i+1);
        l= lett(V[i].v1);
        s= lett(V[i].v2);
        printf("nodo %c, nodo %c, peso %.2f\n", l, s, V[i].peso);    
    }
//------------------------------------------------------------------------------        
 return 0;   
}   
