/*Programma main per lanciare prim.c*/

/* Copyright 2004-2005 by Gianfranco Gignina <shinkuro@amiga.it>
 * All Rights Reserved.
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/

#include <stdio.h>
#include "RicercaOperativaDef.h"

int main(int argc,char **argv)
{
    int i, j, N, nArchi;
    int A[maxM][maxM];
    float P[maxM][maxM];
    char l, s, DG;
    char risp, NFile[maxS], *fileName;
    arco V[maxM*maxM];

    if (argc!=2)
    {
        printf("Benvenuto!\n");
        printf("Sono il programma che ti permettera' di\n");
        printf("trovare il minimo albero ricoprente di un grafo...\n");
        printf("...utilizzando l'algoritmo di Prim!\n");
        printf("\nInserisci il grafo su file *.grf\n");

        printf(": ");
        scanf("%s", NFile);
        fileName = NFile;
    }
    else fileName = argv[1];

    leggiFileF(fileName, A, P, &N, &DG);

    if (N ==0)
    {
        printf("Errore nella lettura del file!");
        return 1;
    }

    nArchi= prim(N, DG, P, V);

    printf("\nIl minimo albero ricoprente di questo grafo e':\n");


    for (i=0; i<nArchi; i++)
    {

        printf("Arco %d: ", i+1);
        l= lett(V[i].v1);
        s= lett(V[i].v2);
        printf("nodo %c, nodo %c, peso %2.2f\n", l, s, V[i].peso);
    }


    return 0;
}
