/*RicercaOperativa.h*/
/*DEFINIZIONI UTILIZZATE DAI PROGRAMMI DI RICERCA OPERATIVA*/
//------------------------------------------------------------------------------
#define maxS 30
#define maxM 10
#define maxR 72
#define maxE 4
#define range 100
#define cellaP 5
#define cellaI 4
#define dimstrgP 6
#define cellaN 2
#define NonE 99
#include <stdlib.h>
#include <stdio.h>
//------------------------------------------------------------------------------


/*STRUTTURE UTILIZZATE DAI PROGRAMMI DI R.O.*/
//******************************************************************************
//------------------------------------------------------------------------------
typedef struct  //definizione di struttura 'arco';
{
    int v1, v2;
    float peso;
} arco;
//------------------------------------------------------------------------------

/* elemTab: Elemento di una tabella negli algoritmi del percorso minimo*/
//------------------------------------------------------------------------------
typedef struct
{
    int vPrec;//nodo precedente;
    float misPerc;// lunghezza del percorso gi attraversato;
    int considerato; // elemento asteriscato;
} elemTab;
//------------------------------------------------------------------------------
//******************************************************************************


/*DICHIARAZIONI DELLE FUNZIONI UTILIZZATE PER GLI ALGORITMI DI R.O.*/
//------------------------------------------------------------------------------
char lett(int n);

int num(char n);

int leggiFileF(char *fileName, int A[][maxM], 
                                        float P[][maxM], int *N, char *DG);

int kruscal(int N, char DG, float P[][maxM], arco *E);

int compareArcP(arco *a, arco *b);

int prim(int N, char DG, float P[][maxM], arco *archiST);

int comparePerc(elemTab *a, elemTab *b);

int dijkstra(int N, int DG, float P[][maxM], int Np, int Na, int *V);

int bellmanford(int N, int DG, float P[][maxM], int Np, int Na, int *V);
//------------------------------------------------------------------------------

/*Definizione di file tipo *.gfr, versione 1.0*/
//******************************************************************************
/*Un file di tipo *.gfr  essenzialmente un file di tipo testo ASCII con alcune
  regole stabilite:

      1) I commenti sono preceduti da un ';' e teoricamente iniziano con un
         'BEGIN' e finiscono con un 'END';

      2) Il carattere di controllo di apertura  rappresentato da '{' (123 in
         ASCII) mentre il carattere di controllo di chiusura  rappresentato da
         '}' (125 in ASCII). Tali caratteri servono rispettivamente per indicare
         che:
              -alla successiva riga di '{' iniziano i dati utili;
              -alla precedente riga di '}' si concludono i dati utili;
              - i dati utili si distinguono attraverso delle lettere:
                  A = matrice di adiacenza;
                  P = matrice dei pesi;

      3) Ciascuna riga di dati riguardanti una matrice rappresenta una riga
         di una matrice generata a partire dai dati forniti dall'utente al
         programma generatore del file *.grf;

      4) Si possono includere delle informazioni addizionali:
              -DGrafo=[s/n] indica se il grafo descritto all'interno del
               file *.grf considerato sia o menu un grafo orientato;
              -nNodi=n indica il numero di nodi che compongono il grafo;
*/
//******************************************************************************


#ifdef __WIN32__
#define SIGBREAKF_CTRL_C 0
int SetSignal(int a, int b);
#endif

#ifdef __AMIGAOS4__
#define __USE_INLINE__
#include <proto/dos.h>
#include <proto/exec.h>
#endif
